/*
 * VITAL-5G monitoring platform
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package it.nextworks.nfvmano.v5g.monitoring.model;

import java.util.Objects;

import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.v3.oas.annotations.media.Schema;
import java.io.IOException;
/**
 * InfrastructureMetric
 */

@javax.annotation.Generated(value = "io.swagger.codegen.v3.generators.java.JavaClientCodegen", date = "2022-07-14T13:52:23.591Z[GMT]")
public class MonitoringInfrastructureMetric extends BaseMetric {
  /**
   * Gets or Sets infrastructureMetricType
   */
  @JsonAdapter(InfrastructureMetricTypeEnum.Adapter.class)
  public enum InfrastructureMetricTypeEnum {
    USER_EXPERIENCED_DOWNLINK_DATA_RATE("USER_EXPERIENCED_DOWNLINK_DATA_RATE"),
    USER_EXPERIENCED_UPLINK_DATA_RATE("USER_EXPERIENCED_UPLINK_DATA_RATE"),
    PACKET_DELIVERY_RATIO("PACKET_DELIVERY_RATIO"),
    PACKET_LOSS("PACKET_LOSS"),
    E2E_LATENCY("E2E_LATENCY"),
    JITTER("JITTER"),
    DROPPED_PACKETS_PER_SECOND("DROPPED_PACKETS_PER_SECOND"),
    FORWARDED_PACKETS_PER_SECOND("FORWARDED_PACKETS_PER_SECOND"),
    DROPPED_BYTES_PER_SECOND("DROPPED_BYTES_PER_SECOND"),
    FORWARDED_BYTES_PER_SECOND("FORWARDED_BYTES_PER_SECOND"),
    DISK_USAGE("DISK_USAGE"),
    CPU_LOAD("CPU_LOAD"),
    GPU_LOAD("GPU_LOAD"),
    RAM_USAGE("RAM_USAGE");

    private String value;

    InfrastructureMetricTypeEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static InfrastructureMetricTypeEnum fromValue(String input) {
      for (InfrastructureMetricTypeEnum b : InfrastructureMetricTypeEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<InfrastructureMetricTypeEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final InfrastructureMetricTypeEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public InfrastructureMetricTypeEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return InfrastructureMetricTypeEnum.fromValue((String)(value));
      }
    }
  }

  @SerializedName("infrastructureMetricType")
  private InfrastructureMetricTypeEnum infrastructureMetricType = null;

  @SerializedName("sliceId")
  private String sliceId = null;

  @SerializedName("vmReference")
  private String vmReference = null;

  /**
   * Gets or Sets metricKPI
   */
  @JsonAdapter(MetricKPIEnum.Adapter.class)
  public enum MetricKPIEnum {
    USER_EXPERIENCED_DOWNLINK_DATA_RATE("USER_EXPERIENCED_DOWNLINK_DATA_RATE"),
    USER_EXPERIENCED_UPLINK_DATA_RATE("USER_EXPERIENCED_UPLINK_DATA_RATE"),
    PACKET_DELIVERY_RATIO("PACKET_DELIVERY_RATIO"),
    PACKET_LOSS("PACKET_LOSS"),
    E2E_LATENCY("E2E_LATENCY"),
    LATENCY("latency"),
    JITTER("JITTER"),
    DROPPED_PACKETS_PER_SECOND("DROPPED_PACKETS_PER_SECOND"),
    FORWARDED_PACKETS_PER_SECOND("FORWARDED_PACKETS_PER_SECOND"),
    DROPPED_BYTES_PER_SECOND("DROPPED_BYTES_PER_SECOND"),
    FORWARDED_BYTES_PER_SECOND("FORWARDED_BYTES_PER_SECOND"),
    DISK_USAGE("DISK_USAGE"),
    CPU_LOAD("CPU_LOAD"),
    GPU_LOAD("GPU_LOAD"),
    RAM_USAGE("RAM_USAGE");

    private String value;

    MetricKPIEnum(String value) {
      this.value = value;
    }
    public String getValue() {
      return value;
    }

    @Override
    public String toString() {
      return String.valueOf(value);
    }
    public static MetricKPIEnum fromValue(String input) {
      for (MetricKPIEnum b : MetricKPIEnum.values()) {
        if (b.value.equals(input)) {
          return b;
        }
      }
      return null;
    }
    public static class Adapter extends TypeAdapter<MetricKPIEnum> {
      @Override
      public void write(final JsonWriter jsonWriter, final MetricKPIEnum enumeration) throws IOException {
        jsonWriter.value(String.valueOf(enumeration.getValue()));
      }

      @Override
      public MetricKPIEnum read(final JsonReader jsonReader) throws IOException {
        Object value = jsonReader.nextString();
        return MetricKPIEnum.fromValue((String)(value));
      }
    }
  }  @SerializedName("metricKPI")
  private MetricKPIEnum metricKPI = null;

  public MonitoringInfrastructureMetric infrastructureMetricType(InfrastructureMetricTypeEnum infrastructureMetricType) {
    this.infrastructureMetricType = infrastructureMetricType;
    return this;
  }

   /**
   * Get infrastructureMetricType
   * @return infrastructureMetricType
  **/
  @Schema(required = true, description = "")
  public InfrastructureMetricTypeEnum getInfrastructureMetricType() {
    return infrastructureMetricType;
  }

  public void setInfrastructureMetricType(InfrastructureMetricTypeEnum infrastructureMetricType) {
    this.infrastructureMetricType = infrastructureMetricType;
  }

  public MonitoringInfrastructureMetric sliceId(String sliceId) {
    this.sliceId = sliceId;
    return this;
  }

   /**
   * Get sliceId
   * @return sliceId
  **/
  @Schema(description = "")
  public String getSliceId() {
    return sliceId;
  }

  public void setSliceId(String sliceId) {
    this.sliceId = sliceId;
  }

  public MonitoringInfrastructureMetric vmReference(String vmReference) {
    this.vmReference = vmReference;
    return this;
  }

   /**
   * Get vmReference
   * @return vmReference
  **/
  @Schema(description = "")
  public String getVmReference() {
    return vmReference;
  }

  public void setVmReference(String vmReference) {
    this.vmReference = vmReference;
  }

  public MonitoringInfrastructureMetric metricKPI(MetricKPIEnum metricKPI) {
    this.metricKPI = metricKPI;
    return this;
  }

   /**
   * Get metricKPI
   * @return metricKPI
  **/
  @Schema(required = true, description = "")
  public MetricKPIEnum getMetricKPI() {
    return metricKPI;
  }

  public void setMetricKPI(MetricKPIEnum metricKPI) {
    this.metricKPI = metricKPI;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    MonitoringInfrastructureMetric monitoringInfrastructureMetric = (MonitoringInfrastructureMetric) o;
    return Objects.equals(this.infrastructureMetricType, monitoringInfrastructureMetric.infrastructureMetricType) &&
        Objects.equals(this.sliceId, monitoringInfrastructureMetric.sliceId) &&
        Objects.equals(this.vmReference, monitoringInfrastructureMetric.vmReference) &&
        Objects.equals(this.metricKPI, monitoringInfrastructureMetric.metricKPI) &&
        super.equals(o);
  }

  @Override
  public int hashCode() {
    return Objects.hash(infrastructureMetricType, sliceId, vmReference, metricKPI, super.hashCode());
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class InfrastructureMetric {\n");
    sb.append("    ").append(toIndentedString(super.toString())).append("\n");
    sb.append("    infrastructureMetricType: ").append(toIndentedString(infrastructureMetricType)).append("\n");
    sb.append("    sliceId: ").append(toIndentedString(sliceId)).append("\n");
    sb.append("    vmReference: ").append(toIndentedString(vmReference)).append("\n");
    sb.append("    metricKPI: ").append(toIndentedString(metricKPI)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}
